package casualtest;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.OutputStream;

import junit.framework.TestCase;

import org.junit.Test;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.io.FileDocumentTarget;
import org.semanticweb.owlapi.io.OWLOntologyDocumentTarget;
import org.semanticweb.owlapi.io.StreamDocumentTarget;
import org.semanticweb.owlapi.io.StringDocumentTarget;
import org.semanticweb.owlapi.io.WriterDocumentTarget;
import org.semanticweb.owlapi.io.ZipDocumentTarget;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyManager;
@SuppressWarnings("javadoc")
public class StreamOpenTest extends TestCase {
    @Test
	public void testStreamStaysOpen() throws Exception {
		OWLOntologyManager m = OWLManager.createOWLOntologyManager();
		OWLOntology o = m.createOntology();
		OutputStream out = new ByteArrayOutputStream();

			m.saveOntology(o, out);
			out.write("all right".getBytes());
			File file = File.createTempFile("test", "owlapi");
			FileDocumentTarget f1 = new FileDocumentTarget(file);

			m.saveOntology(o, f1);
			f1.getOutputStream().write("all right".getBytes());
			f1.getOutputStream().close();
			StreamDocumentTarget f2 = new StreamDocumentTarget(
					new FileOutputStream(file));
			m.saveOntology(o, f2);
			f2.getOutputStream().write("all right".getBytes());
			f2.getOutputStream().close();
			OWLOntologyDocumentTarget f3 = new StringDocumentTarget();
			//Writer out3 = f3.getWriter();
			m.saveOntology(o, f3);

			f3.getWriter().append("all right");
			//f3.getOutputStream().close();
			WriterDocumentTarget f4 = new WriterDocumentTarget(new FileWriter(
					file));
			m.saveOntology(o, f4);
			f4.getWriter().append("all right");
			f4.getWriter().close();
			file.deleteOnExit();
			File f = new File("ziptest_deletesafely.zip");
			ZipDocumentTarget f5 = new ZipDocumentTarget(f);
			OutputStream outputStream = f5.getOutputStream();
			m.saveOntology(o, outputStream);
			outputStream.write("all right".getBytes());
			outputStream.close();
			f.deleteOnExit();

	}
}
